### Constructor

# Cogl Texture2DSliced new_from_data

#### Declaration [src]

    CoglTexture*
    cogl_texture_2d_sliced_new_from_data (
      CoglContext* ctx,
      int width,
      int height,
      int max_waste,
      CoglPixelFormat format,
      int rowstride,
      const uint8_t* data,
      GError** error
    )

#### Description [src]

Creates a new `CoglTexture2DSliced` texture based on data residing in memory.

A `CoglTexture2DSliced` may internally be comprised of 1 or more `CoglTexture2D` textures depending on GPU limitations. For example if the GPU only supports power-of-two sized textures then a sliced texture will turn a non-power-of-two size into a combination of smaller power-of-two sized textures. If the requested texture size is larger than is supported by the hardware then the texture will be sliced into smaller textures that can be accessed by the hardware.

`max_waste` is used as a threshold for recursively slicing the right-most or bottom-most slices into smaller sizes until the wasted padding at the bottom and right of the textures is less than specified. A negative `max_waste` will disable slicing.

This api will always immediately allocate GPU memory for all the required texture slices and upload the given data so that the `data` pointer does not need to remain valid once this function returns. This means it is not possible to configure the texture before it is allocated. If you do need to configure the texture before allocation (to specify constraints on the internal format for example) then you can instead create a `CoglBitmap` for your data and use `cogl_texture_2d_sliced_new_from_bitmap()` or use `cogl_texture_2d_sliced_new_with_size()` and then upload data using `cogl_texture_set_data()`

It’s possible for the allocation of a sliced texture to fail due to impossible slicing constraints if a negative `max_waste` value is given. If the given virtual texture size is larger than is supported by the hardware but slicing is disabled the texture size would be too large to handle.

#### Parameters

`ctx`

  Type: `CoglContext`

  A `CoglContext`.

  The data is owned by the caller of the function.

`width`

  Type: `int`

  Width of texture in pixels.

`height`

  Type: `int`

  Height of texture in pixels.

`max_waste`

  Type: `int`

  The threshold of how wide a strip of wasted texels are allowed along the right and bottom textures before they must be sliced to reduce the amount of waste. A negative can be passed to disable slicing.

`format`

  Type: `CoglPixelFormat`

  The `CoglPixelFormat` the buffer is stored in in RAM.

`rowstride`

  Type: `int`

  The memory offset in bytes between the start of each row in `data`. A value of 0 will make Cogl automatically calculate `rowstride` from `width` and `format`.

`data`

  Type: An array of `uint8_t`

  Pointer the memory region where the source buffer resides.

  The data is owned by the caller of the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the constructor if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `CoglTexture`

A newly created `CoglTexture2DSliced` or `NULL` on failure and `error` will be updated.

The caller of the function takes ownership of the data, and is responsible for freeing it.